## ros-humble-schunk-svh-library 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(schunk_svh_library VERSION 1.0 DESCRIPTION "C++ driver library for the Schunk SVH")

# CMake will automatically update this library's version in the
# SVHVersionConfig.h include.
configure_file(include/schunk_svh_library/VersionConfig.h.in SVHVersionConfig.h)

# We require this C++ standard
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED True)

# System dependencies
find_package(Threads REQUIRED)
find_package(Boost COMPONENTS unit_test_framework REQUIRED)

# --------------------------------------------------------------------------------
# Make sure that library relocation works for both build and install.
# See here: https://gitlab.kitware.com/cmake/community/-/wikis/doc/cmake/RPATH-handling
# --------------------------------------------------------------------------------

set(CMAKE_SKIP_BUILD_RPATH FALSE)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# The RPATH to use when installing, but only if it's not a system directory
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
endif("${isSystemDir}" STREQUAL "-1")

# --------------------------------------------------------------------------------
# User library
# --------------------------------------------------------------------------------
add_library(svh-library SHARED
        src/control/SVHController.cpp
        src/control/SVHFingerManager.cpp
        )

# Provide an alias target for our users' call to target_link_libraries()
add_library(Schunk::svh-library ALIAS svh-library)

target_include_directories(svh-library PUBLIC
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
        )

target_link_libraries(svh-library PUBLIC
        svh-serial
        )


# --------------------------------------------------------------------------------
# Internal libraries
# --------------------------------------------------------------------------------
add_library(svh-serial SHARED
        src/LogHandler.cpp
        src/serial/ByteOrderConversion.cpp
        src/serial/Serial.cpp
        src/serial/SerialFlags.cpp
        src/serial/SVHReceiveThread.cpp
        src/serial/SVHSerialInterface.cpp
        src/serial/SVHSerialPacket.cpp
        )

add_library(Schunk::svh-serial ALIAS svh-serial)

target_include_directories(svh-serial PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
        )

target_link_libraries(svh-serial PUBLIC
        )
target_compile_definitions(svh-serial PUBLIC
        -D_SYSTEM_LINUX_
        -D_SYSTEM_POSIX_
        )
if(THREADS_HAVE_PTHREAD_ARG)
  target_compile_options(svh-serial PUBLIC "-pthread")
endif()
if(CMAKE_THREAD_LIBS_INIT)
  target_link_libraries(svh-serial PUBLIC "${CMAKE_THREAD_LIBS_INIT}")
endif()


# --------------------------------------------------------------------------------


# --------------------------------------------------------------------------------
# Tests
# --------------------------------------------------------------------------------
add_executable(test_driver_svh
        test/driver_svh/MainTest.cpp
        test/driver_svh/ByteOrderConversionTest.cpp
        test/driver_svh/SVHDriverTest.cpp
        )
target_include_directories(test_driver_svh PUBLIC
        ${PROJECT_SOURCE_DIR}/include
        )
target_link_libraries(test_driver_svh
        ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
        svh-library
        )
target_compile_definitions(test_driver_svh PUBLIC
        -D_SYSTEM_LINUX_
        -D_SYSTEM_POSIX_
        -DBOOST_TEST_DYN_LINK
        )
add_test(NAME test_driver_svh COMMAND test_driver_svh)

# --------------------------------------------------------------------------------

add_executable(test_svh_send_packet
        test/serial_interface/SVHSendPacketTest.cpp
        )
target_include_directories(test_svh_send_packet PUBLIC
        ${PROJECT_SOURCE_DIR}/include
        )
target_link_libraries(test_svh_send_packet
        ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
        svh-serial
        )
add_test(NAME test_svh_send_packet COMMAND test_svh_send_packet)

# --------------------------------------------------------------------------------

#add_executable(test_svh_receive
#        test/serial_interface/SVHReceiveTest.cpp
#        )
#target_include_directories(test_svh_receive PUBLIC
#        ${PROJECT_SOURCE_DIR}/include
#        )
#target_link_libraries(test_svh_receive
#        ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
#        svh-serial
#        )
#add_test(NAME test_svh_receive COMMAND test_svh_receive)
#set_tests_properties(test_svh_receive PROPERTIES TIMEOUT 10)

# --------------------------------------------------------------------------------

add_executable(test_svh_send_feedback_packet
        test/serial_interface/SVHSendFeedbackPacketTest.cpp
        )
target_include_directories(test_svh_send_feedback_packet PUBLIC
        ${PROJECT_SOURCE_DIR}/include
        )
target_link_libraries(test_svh_send_feedback_packet
        ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
        svh-serial
        )
add_test(NAME test_svh_send_feedback_packet COMMAND test_svh_send_feedback_packet)

# --------------------------------------------------------------------------------

add_executable(test_svh_controller_init_send
        test/serial_interface/SVHControllerInitSendTest.cpp
        )
target_include_directories(test_svh_controller_init_send PUBLIC
        ${PROJECT_SOURCE_DIR}/include
        )
target_link_libraries(test_svh_controller_init_send
        ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
        svh-library
        )
add_test(NAME test_svh_controller_init_send COMMAND test_svh_controller_init_send)

# --------------------------------------------------------------------------------

add_executable(test_svh_finger_manager
        test/serial_interface/SVHFingerManagerTest.cpp
        )
target_include_directories(test_svh_finger_manager PUBLIC
        ${PROJECT_SOURCE_DIR}/include
        )
target_link_libraries(test_svh_finger_manager
        ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
        svh-library
        )
add_test(NAME test_svh_finger_manager COMMAND test_svh_finger_manager)

# --------------------------------------------------------------------------------

enable_testing()

# --------------------------------------------------------------------------------
# Export and install
# --------------------------------------------------------------------------------
install(TARGETS
        svh-library
        svh-serial
        EXPORT schunk_svh_library_targets
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION bin
        INCLUDES DESTINATION include
        )

# Create and install a file with all exported targets
install(EXPORT schunk_svh_library_targets
        DESTINATION lib/cmake/schunk_svh_library
        FILE schunk_svh_libraryTargets.cmake
        NAMESPACE Schunk::
        )

# Install the Config file so that find_package() works with this package
install(FILES schunk_svh_libraryConfig.cmake
        DESTINATION lib/cmake/schunk_svh_library
        )

# Install the include directories
install(DIRECTORY include/schunk_svh_library
  DESTINATION include
  FILES_MATCHING PATTERN "*.h")

#### Begin import ####
# Imported from ros-industrial/ros_industrial_cmake_boilerplate
# https://github.com/ros-industrial/ros_industrial_cmake_boilerplate/blob/master/ros_industrial_cmake_boilerplate/cmake/cmake_tools.cmake
# Copyright (C) 2018 by George Cave - gcave@stablecoder.ca
# Copyright (c) 2020, Southwest Research Institute
# Licensed under Apache-2.0 license

# Allows Colcon to find non-Ament packages when using workspace underlays
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/${PROJECT_NAME} "")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/${PROJECT_NAME} DESTINATION share/ament_index/resource_index/packages)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ament_prefix_path.dsv "prepend-non-duplicate;AMENT_PREFIX_PATH;")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ament_prefix_path.dsv DESTINATION share/${PROJECT_NAME}/hook)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ros_package_path.dsv "prepend-non-duplicate;ROS_PACKAGE_PATH;")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ros_package_path.dsv DESTINATION share/${PROJECT_NAME}/hook)
#### End import ####

=== debian/changelog ===
ros-humble-schunk-svh-library (1.0.1-1jammy) jammy; urgency=high

  * Fix Errno 22 invalid argument for reading serial devices on ARM PCs
    This fixes an unsafe cast in select's timeout parameter, which somehow
    only seemed to cause issues on a recent Raspberry Pi 4.
  * Add CI for ROS2 Foxy and Humble
  * Add license badge to the top-level readme
    That's easier for users to see.
  * Fix workflows' file extension
  * Merge pull request #1 <https://github.com/fzi-forschungszentrum-informatik/schunk_svh_library/issues/1> from fzi-forschungszentrum-informatik/add-github-ci
    Add GitHub ci
  * Add build badges to top-level readme
  * Activate CI for ROS Melodic and Noetic
  * Merge branch 'fix-hardware-unit-test' into 'master'
    Outcomment hardware-dependend unit test
    See merge request hardware-drivers/schunk_svh_library!33
  * Outcomment hardware-dependend unit test
  * Merge branch 'update-maintainer' into 'master'
    Update maintainer
    See merge request hardware-drivers/schunk_svh_library!32
  * Update maintainer
  * Merge branch 'update-license' into 'master'
    Switch to GPLv3 license
    See merge request hardware-drivers/schunk_svh_library!31
  * Fix typo in license notice
  * Add license notice to all development files
    The text is in accordance with the recommendations from
    here <https://www.gnu.org/licenses/gpl-howto.html>
    in the section *The license notices*.
  * Add license notice for convenience
    Putting this language-specific summary in a separate folder is according
    to the ROS developers suggestions: http://wiki.ros.org/DevelopersGuide
  * Update SPDX license indicator in package.xml
    This is according to
    here <https://www.gnu.org/licenses/identify-licenses-clearly.html>.
  * Add license text for the GPLv3
    The license text is from
    here <https://www.gnu.org/licenses/gpl-3.0.txt> after following the
    recommendations from here <https://www.gnu.org/licenses/gpl-howto.html>.
  * Added downstream workspaces
  * Fixed library exports
  * Export LIBRARIES and INCLUDE_DIRS
    This is important for legacy cmake systems such as catkin
  * Use needs instead of dependencies
  * Merge branch 'update-and-upgrade' into 'master'
    Make this a standalone library for driver development
    Closes #11 <https://github.com/fzi-forschungszentrum-informatik/schunk_svh_library/issues/11>
    See merge request hardware-drivers/schunk_svh_library!25
  * Contributors: Felix Exner, Stefan Scherzinger

 -- Stefan Scherzinger <scherzin@fzi.de>  Mon, 19 Dec 2022 23:00:00 -0000

=== debian/control ===
Source: ros-humble-schunk-svh-library
Section: misc
Priority: optional
Maintainer: Stefan Scherzinger <scherzin@fzi.de>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libboost-all-dev <!nocheck>, ros-humble-ros-workspace
Homepage: http://wiki.ros.org/schunk_svh_library
Standards-Version: 3.9.2

Package: ros-humble-schunk-svh-library
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-ament-cmake, ros-humble-ros-workspace
Description: Standalone C++ library for accessing the Schunk five finger hand.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-schunk-svh-library//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-schunk-svh-library//opt/ros/humble/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
